d# -*- coding: utf-8 -*-
"""
Created on Tue Aug 08 13:53:55 2017

@author: Jack C Press
"""
import networkx as nx
import os
import csv
from Preprocessing_Parsing import *

os.chdir('path_to_file')

#MAKE NETWORKX GRAPH. Length_Graph uses length and Weighted_Length_Graph uses wghtd
Length_Graph = nx.Graph()
Weighted_Length_Graph = nx.Graph()
start = []
for i in range(len(path)):
    Length_Graph.add_path(path[i],OID=ID[i], 
                                  weight=length[i]/(len(path[i])-1))
    
    Weighted_Length_Graph.add_path(path[i],OID=ID[i], 
                                   weight=wt[i]/(len(path[i])-1), 
                                   Length=length[i])

#connect missing path near plant
Weighted_Length_Graph.add_path([(lat1, lon1),
                                (lat2, lon2)], 
    weight=50.0, Length=100)

#add Chlorine Monitoring Stations to Graph
Length_Graph.add_nodes_from(Psources)

#Set up dictionary which represents node coordinates. IN this case, our nodes ARE coordinates
pos = dict(zip(Length_Graph.nodes(), Length_Graph.nodes()))
Pos = dict(zip(Weighted_Length_Graph.nodes(), Weighted_Length_Graph.nodes()))

M8 = single_source_dijkstra_path_length(Length_Graph, sources[0], cutoff=None, weight='weight')
M7 = single_source_dijkstra_path_length(Length_Graph, sources[1], cutoff=None, weight='weight')
M6 = single_source_dijkstra_path_length(Length_Graph, sources[2], cutoff=None, weight='weight')
M5 = single_source_dijkstra_path_length(Length_Graph, sources[3], cutoff=None, weight='weight')
M4 = single_source_dijkstra_path_length(Length_Graph, sources[4], cutoff=None, weight='weight')
M3 = single_source_dijkstra_path_length(Length_Graph, sources[5], cutoff=None, weight='weight')
M2 = single_source_dijkstra_path_length(Length_Graph, sources[6], cutoff=None, weight='weight')
M1 = single_source_dijkstra_path_length(Length_Graph, sources[7], cutoff=None, weight='weight')
M9 = single_source_dijkstra_path_length(Length_Graph, sources[8], cutoff=None, weight='weight')
M10 = single_source_dijkstra_path_length(Length_Graph, sources[9], cutoff=None, weight='weight')


M8 = M8.values()
M7 = M7.values()
M6 = M6.values()
M5 = M5.values()
M4 = M4.values()
M3 = M3.values()
M2 = M2.values()
M1 = M1.values()
M9 = M9.values()
M10 = M10.values() 
MinPathExcel = ['=MIN(B2,C2,D2,E2,F2,G2,H2,I2,J2,K2)']*len(M8)
MonAssignExcel = ['=MATCH(L2,B2:K2, )']*len(M8)
DATA = zip(Length_Graph.nodes(), M1, M2, M3, M4, M5, M6, M7, M8, M10, M9, MinPathExcel, MonAssignExcel)

with open('Monitoring Stations Shortest Paths.csv', 'wb') as f:  
    w = csv.writer(f)
    w.writerow(['WN_ND_Junctions', 'Distance to M1', 'Distance to M2', 
                'Distance to M3', 'Distance to M4', 'Distance to M5', 
                'Distance to M6', 'Distance to M7', 'Distance to M8', 
                'Distance to M10', 
                'Distance to M9',
                'Shortest Distance', 'Monitor Assignment'])
    for line in DATA:
        w.writerow(line)