# -*- coding: utf-8 -*-
"""
Created on Mon Jan 22 11:46:51 2018

@author: Jack C Press
"""

from osgeo import gdal 
import fiona
import json
import os
from scipy import spatial
import pandas as pd
import utm
from dbfread import DBF

os.chdir('path_to_file')

#PARSE THE DATA. SHP->GEOJSON-> []
#First Get The Edges
edge_features = fiona.open('Flint_Paths.geojson')
path,length, wt, ID = [], [], [], []
for feature in edge_features:
    length.append(feature['properties']['Shape_Le_1'])
    path.append(feature['geometry']['coordinates'])
    wt.append(feature['properties']['Wghtd'])
    ID.append(feature['id'])
#Then Get The Nodes    
node_features = fiona.open('Flint_Nodes.geojson')
nodes, nodeid = [], []
for feature in node_features:
    nodes.append(feature['geometry']['coordinates'])
    nodeid.append(feature['id'])
    
#Open the Chlorine Monitor Data GEOJSON and Parse the Data    
with open('flint_stations.geojson') as D:
    data = json.load(D)
stations, I_D, CT = [], [], []

for feature in data['features']:
    stations.append((feature['geometry']['coordinates']))
    I_D.append(feature['properties']['Num'])
    CT.append(feature['properties']['CT'])
    
sources, distanceindex, latlon, Psources, Pdistanceindex = [], [], [], [] , []
for station in stations:
    sources.append(nodes[spatial.KDTree(nodes).query(station)[1]])
    distanceindex.append(spatial.KDTree(nodes).query(station))
for record in DBF('path_to_file...\FlintParcels.dbf'):
    latlon.append((float(record['X_text']) , float(record['Y_text'])))
for coordinate in latlon:
    Psources.append(nodes[spatial.KDTree(nodes).query(coordinate)[1]])
    Pdistanceindex.append(spatial.KDTree(nodes).query(coordinate))